package hr.fer.tel.ruazosa.lectures;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import hr.fer.tel.ruazosa.lectures.entity.Course;
import hr.fer.tel.ruazosa.lectures.entity.ShortCourse;
import hr.fer.tel.ruazosa.lectures.entity.ShortPerson;
import hr.fer.tel.ruazosa.lectures.net.RestFactory;
import hr.fer.tel.ruazosa.lectures.net.RestInterface;

public class CourseDetailsActivity extends AppCompatActivity {

    private Course course;
    private TextView courseName;
    private TextView courseDescription;
    private TextView teacher;
    private Button courseStudentsButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_course_details);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        courseName = (TextView) findViewById(R.id.courseName);
        courseDescription = (TextView) findViewById(R.id.courseDescription);
        teacher = (TextView) findViewById(R.id.courseTeacher);
        courseStudentsButton = (Button) findViewById(R.id.courseStudentsButton);


        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });

        ShortCourse shortCourse = (ShortCourse)
                getIntent().getSerializableExtra("course");

        AsyncTask<ShortCourse, Void, Course> task = new AsyncTask<ShortCourse, Void, Course>() {
            @Override
            protected Course doInBackground(ShortCourse... sCourse) {
                RestInterface rest = RestFactory.getInstance();

                return rest.getCourse(sCourse[0].getId());
            }

            @Override
            protected void onPostExecute(Course newCourse) {
                course = newCourse;
                courseName.setText(course.getName());
                courseDescription.setText(course.getDescription());

                ShortPerson teacher = course.getTeacher();
                if(teacher != null)
                    CourseDetailsActivity.this.teacher.setText(teacher.getName());
            }
        };

        task.execute(shortCourse);

        courseStudentsButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(CourseDetailsActivity.this, StudentsActivity.class);
                intent.putExtra("courseId", course.getId());
                startActivity(intent);
            }
        });
    }

}
