package hr.fer.tel.ruazosa.lectures;

import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.util.List;

import hr.fer.tel.ruazosa.lectures.entity.Course;
import hr.fer.tel.ruazosa.lectures.entity.ShortCourse;
import hr.fer.tel.ruazosa.lectures.entity.ShortPerson;
import hr.fer.tel.ruazosa.lectures.net.RestFactory;
import hr.fer.tel.ruazosa.lectures.net.RestInterface;

public class StudentsActivity extends AppCompatActivity {

    ListView studentListView;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_students);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });

        studentListView = (ListView) findViewById(R.id.studentsListView);
        Long courseId = (Long) getIntent().getSerializableExtra("courseId");


        AsyncTask<Long, Void, List<ShortPerson>> task = new AsyncTask<Long, Void, List<ShortPerson>>() {
            @Override
            protected List<ShortPerson> doInBackground(Long... courseId) {
                RestInterface rest = RestFactory.getInstance();

                return rest.getCourseStudents(courseId[0]);
            }

            @Override
            protected void onPostExecute(List<ShortPerson> list) {
                updateStudentList(list);
            }
        };

        task.execute(courseId);

    }

    private void updateStudentList(List<ShortPerson> list) {
        StudentAdapter adapter = new StudentAdapter(this,
                android.R.layout.simple_list_item_1, list);
        studentListView.setAdapter(adapter);
    }

    private class StudentAdapter extends ArrayAdapter<ShortPerson> {
        private List<ShortPerson> shortPersonList;

        public StudentAdapter(Context context, int textViewResourceId, List<ShortPerson> persons) {
            super(context, textViewResourceId, persons);
            shortPersonList = persons;
        }
    }

}
