package hr.fer.tel.ruazosa.lectures.net.resttemplate;

import android.util.Log;
import android.view.Menu;

import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.client.RestTemplate;

import java.net.URL;
import java.util.LinkedList;
import java.util.List;

import hr.fer.tel.ruazosa.lectures.entity.Course;
import hr.fer.tel.ruazosa.lectures.entity.Person;
import hr.fer.tel.ruazosa.lectures.entity.ShortCourse;
import hr.fer.tel.ruazosa.lectures.entity.ShortPerson;
import hr.fer.tel.ruazosa.lectures.net.RestFactory;
import hr.fer.tel.ruazosa.lectures.net.RestInterface;

public class RestSpringTemplete implements RestInterface {
    private final String baseURL;

    public RestSpringTemplete() {
        baseURL = "http://" + RestFactory.BASE_IP + ":8080/api";
    }

    @Override
    public List<ShortCourse> getListOfCourses() {
        try {
            RestTemplate restTemplate = new RestTemplate();
            restTemplate.getMessageConverters().add(new MappingJackson2HttpMessageConverter());

            List<ShortCourse> courseList = restTemplate.getForObject(baseURL + "/courses", ShortCourseList.class);

            return courseList;
        } catch (Exception e) {
            Log.i("RUAZOSA", e.getMessage(), e);
        }

        return null;
    }

    public static class ShortCourseList extends LinkedList<ShortCourse> {}

    @Override
    public Course getCourse(Long id) {
        try {
            RestTemplate restTemplate = new RestTemplate();
            restTemplate.getMessageConverters().add(new MappingJackson2HttpMessageConverter());

            Course course = restTemplate.getForObject(baseURL + "/courses/" + id, Course.class);

            return course;
        } catch (Exception e) {
            Log.i("RUAZOSA", e.getMessage(), e);
        }

        return null;
    }

    @Override
    public List<ShortPerson> getCourseStudents(Long courseId) {
        try {
            RestTemplate restTemplate = new RestTemplate();
            restTemplate.getMessageConverters().add(new MappingJackson2HttpMessageConverter());

            List<ShortPerson> personList = restTemplate.getForObject(baseURL + "/courses/" + courseId + "/students", ShortPersonList.class);

            return personList;
        } catch (Exception e) {
            Log.i("RUAZOSA", e.getMessage(), e);
        }

        return null;
    }

    public static class ShortPersonList extends LinkedList<ShortPerson> {}

    @Override
    public List<ShortPerson> getListOfPersons() {
        throw new UnsupportedOperationException();
    }

    @Override
    public Person getPerson(Long id) {
        throw new UnsupportedOperationException();
    }

    @Override
    public boolean enrollPersonToCourse(Long personId, Long courseId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public boolean unenrollPersonFromCourse(Long personId, Long courseId) {
        throw new UnsupportedOperationException();
    }
}
