package hr.fer.tel.ruazosa.lectures.net.retrofit;

import android.util.Log;

import java.io.IOException;
import java.util.List;

import hr.fer.tel.ruazosa.lectures.entity.Course;
import hr.fer.tel.ruazosa.lectures.entity.Person;
import hr.fer.tel.ruazosa.lectures.entity.ShortCourse;
import hr.fer.tel.ruazosa.lectures.entity.ShortPerson;
import hr.fer.tel.ruazosa.lectures.net.RestFactory;
import hr.fer.tel.ruazosa.lectures.net.RestInterface;
import retrofit.RestAdapter;

public class RestRetrofit implements RestInterface {
    private final String baseURL;
    private final LecturesService service;

    public RestRetrofit() {
        baseURL = "http://" + RestFactory.BASE_IP + ":8080/api/";
        RestAdapter retrofit = new RestAdapter.Builder()
                .setEndpoint(baseURL)
                .build();

        service = retrofit.create(LecturesService.class);
    }

    @Override
    public List<ShortCourse> getListOfCourses() {
        return service.getListOfCourses();
    }

    @Override
    public Course getCourse(Long id) {
        return service.getCourse(id);
    }

    @Override
    public List<ShortPerson> getCourseStudents(Long courseId) {
        return service.getCourseStudents(courseId);
    }

    @Override
    public List<ShortPerson> getListOfPersons() {
        throw new UnsupportedOperationException();
    }

    @Override
    public Person getPerson(Long id) {
        throw new UnsupportedOperationException();
    }

    @Override
    public boolean enrollPersonToCourse(Long personId, Long courseId) {
        throw new UnsupportedOperationException();
    }

    @Override
    public boolean unenrollPersonFromCourse(Long personId, Long courseId) {
        throw new UnsupportedOperationException();
    }
}
